/* -----------------------------------------------------------------------
 `str_shorten' shortens file name to FAT convention. This function does
 not check for existence of file with the same name; it's just an
 algorithm to reduce number of dots and symbols.
 parameter: s - original filename
 returns: statically allocated buffer with converted string, of NULL if failed
 -----------------------------------------------------------------------  */
char *str_shorten (char *s);

/* returns number of chars 'c' in string 's' */
int  str_numchars (char *s, char c);

/* removes chars from 'stray' at the tail of string 's' if present */
void str_strip (char *s, char *stray);

/* copies `src' to `dest', reducing it to `dest_len' symbols */
void str_reduce (char *dest, char *src, int dest_len);

/* returns 1 if 'c' can be used in FAT filename, or 0 if not */
int  str_fatsafe (char c);

/* returns 1 if 'c' is vowel, and 0 if not */
int  str_isvowel (char c);

/* removes char at position 'p' from string 's'. \0 won't be removed */
void str_delete (char *s, char *p);

/* returns 0 if string 's' ends with 'tail', 1 if not */
int  str_tailcmp (char *s, char *tail);

/* returns 0 if string 's' ends with 'tail', 1 if not.
 compare is not case-sensitive */
int  str_tailcmpi (char *s, char *tail);

/* makes string 's' one byte shorter */
void str_try_shorten (char *s);

/* returns last character in 's' belonging to set in 'accept';
 NULL if not found */
char *str_lastspn (char *s, char *accept);
